package Echiquier.Piece;

import Echiquier.Case;
import Echiquier.ColorJoueur;
import Echiquier.Echiquier;

public abstract class Piece {
    Case unCase;
    ColorJoueur colorJoueur;
    Echiquier echiquier;
    public Piece(Case unCase, ColorJoueur colorJoueur)
    {
        this.unCase = unCase;
        this.colorJoueur = colorJoueur;
    }

    public abstract void deplace(Case arrive);

    public void deplace(Piece piece, Case arrive){
        this.unCase = arrive;
        getTable()[arrive.getLig()][arrive.getCol()].setPiece(piece);
    };

    public void deplaceInvalid(Case arrive){
        System.out.println("Il n'est pas possible de déplacer la pièce en " + unCase.toString() + "vers " + arrive.toString() + "!");
    }

    public Case getUnCase() {
        return unCase;
    }

    public void setUnCase(Case unCase) {
        this.unCase = unCase;
    }

    public ColorJoueur getColorJoueur() {
        return colorJoueur;
    }

    public Echiquier getEchiquier() {
        return echiquier;
    }

    public void setEchiquier(Echiquier echiquier) {
        this.echiquier = echiquier;
    }

    public Case[][] getTable(){
        return this.echiquier.getTable();
    }
}
